
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 */

#ifndef __BLOCK_H__
#define __BLOCK_H__

#ifndef __OBJECT_INCLUDED__
#define __OBJECT_INCLUDED__
#include "Object.h" /* Stepstone Object.h assumes #import */
#endif

#ifndef OBJCRTEXPORT
#define OBJCRTEXPORT /* empty */
#endif

/* allows"manual" construction of Blocks, ie. without compiler support */
extern id OBJCRTEXPORT newBlock(int n,IMP fn,void*data);

@interface Block : Object
{
	int nVars;
	IMP fn; /* it's not _really_ an IMP, it's just a func pointer */
	void* data;
}

+ errorHandler;
+ errorHandler:aHandler;
- ifError:aHandler;
- value:anObject ifError:aHandler;

- value;
- atExit;
- value:anObject;
- value:firstObject value:secondObject;

- repeatTimes:(int)n;
@end

/* some defs needed when cross-compiling with a DIFFERENT compiler */
/* placed this here 'cause we will have a different objcrt.h and Object.h */

#if !defined(__PORTABLE_OBJC__) && !defined(OCLONGLONG)

void *OC_Malloc(size_t); /* allocate memory from the system */
void *OC_MallocAtomic(size_t); /* allocate memory from the system */
void *OC_Realloc(void *,size_t);/* reallocate memory from the system */
void *OC_Free(void *data);/* deallocate OC_Malloc'ed memory and return NULL */

#endif /* __PORTABLE_OBJC__ */

#endif /* __BLOCK_H__ */

