
/*
 * Computer Algebra Kit (c) 1993,98 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __ca_intobj_vector_header__
#define __ca_intobj_vector_header__

#include "vectorc.h"

typedef struct ca_intobjvec {
    int		n;
    int		c;
    ca_intobjseq_t	ptr;
} *ca_intobjvec_t;

typedef struct ca_intobjvec ca_intobjvec_c;
typedef struct { ca_intobj_args sargs; } ca_intobjvec_args;

#define ca_intobjvec_isvalue	0
#define ca_intobjvec_pervalue	0

typedef struct ca_intobjvec_ix {
    int i;
    int n;
} *ca_intobjvec_ixt;

@interface ca_intobj_vector : ca_vector
{
    id				scalarZero;
    struct ca_intobjvec		value;
}

- check;

- _setUpScalarZero:aScalarZero numScalars:(int)numScalars;
+ scalarZero:aScalarZero numScalars:(int)numScalars;
- copy;
- deepCopy;
- clear;
- (ca_intobjvec_t)ca_intobjvec_value;
- ca_intobjvec_value:(ca_intobjvec_t)aValue;
- (ca_intobjvec_t)ca_intobjvec_reference;
- ca_intobjvec_reference:(ca_intobjvec_c *)aReference;

- clone;
- capacity:(int)aCapacity;
- numScalars:(int)numScalars;

- scalarZero;
- (int) numScalars;

- insertScalar:aScalar;
- insertScalar:aScalar at:(int)i;

- removeScalar;
- removeScalarAt:(int)i;

- placeScalar:aScalar at:(int)i;
- replaceScalarAt:(int)i with:aScalar;

- eachScalar;
- elt_ca_intobjvec_ix:(ca_intobjvec_ixt)ix;

- dotMultiply:b;
- dotSquare;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
- (unsigned) hash;
- (BOOL) isEqual:b;
- (BOOL) notEqual:b;
- (BOOL) isZero;
- (BOOL) notZero;
- (BOOL) isOpposite:b;
- (BOOL) notOpposite:b;
- negate;
- negateSelf;
- _double:(int)v;
- _doubleSelf:(int)v;
- double;
- doubleSelf;
- _add:(int)v:b:(int)w;
- _addSelf:(int)v:b:(int)w;
- add:b;
- addSelf:b;
- subtract:b;
- subtractSelf:b;
- multiplyScalar:s;
- multiplySelfScalar:s;
- divideScalar:s;
- divideSelfScalar:s;
- _add:(int)v:B multiplyScalar:b:(int)w;
- _addSelf:(int)v:B multiplyScalar:b:(int)w;
- _multiplyScalar:a:(int)v add:B:(int)w;
- _multiplySelfScalar:a:(int)v add:B:(int)w;
- _multiplyScalar:a:(int)v add:B multiplyScalar:b:(int)w;
- _multiplySelfScalar:a:(int)v add:B multiplyScalar:b:(int)w;
@end

#endif /* __ca_intobj_vector_header__ */

