
/*
 * Portable Object Compiler (c) 1997 by Stes & Lerman.
 * All Rights Reserved.
 */


#include "objc1.h"
#include "yaccplus.h" /* different for C/C++ */

/*
 * TokenName function for C++ lexical scanner.
 */

char *tokenName(int token)
{
	switch(token) {
		case AUTO_TOKEN : return "auto";
		case BREAK_TOKEN : return "break";
		case CASE_TOKEN : return "case";
		case CHAR_TOKEN : return "char";
		case CONTINUE_TOKEN : return "continue";
		case DEFAULT_TOKEN : return "default";
		case DO_TOKEN : return "do";
		case DOUBLE_TOKEN : return "double";
		case ELSE_TOKEN : return "else";
		case ENUM_TOKEN : return "enum";
		case EXTERN_TOKEN : return "extern";
		case FLOAT_TOKEN : return "float";
		case FOR_TOKEN : return "for";
		case GOTO_TOKEN : return "goto";
		case IF_TOKEN : return "if";
		case INT_TOKEN : return "int";
		case LONG_TOKEN : return "long";
		case REGISTER_TOKEN : return "register";
		case RETURN_TOKEN : return "return";
		case SHORT_TOKEN : return "short";
		case SIZEOF_TOKEN : return "sizeof";
		case STATIC_TOKEN : return "static";
		case STRUCT_TOKEN : return "struct";
		case SWITCH_TOKEN : return "switch";
		case TYPEDEF_TOKEN : return "typedef";
		case UNION_TOKEN : return "union";
		case UNSIGNED_TOKEN : return "unsigned";
		case VOID_TOKEN : return "void";
		case WHILE_TOKEN : return "while";
		
		case SIGNED_TOKEN : return 	"signed";
		case VOLATILE_TOKEN : return "volatile";
		
		case ATDEFS_TOKEN : return "@defs";
		case ATSELECTOR_TOKEN : return "@selector";
		case ATEND_TOKEN : return "@end";
		case ATENCODE_TOKEN : return "@encode";
		case ID_TOKEN : return "id";
		
		case INLINE_TOKEN : return "inline";
		
		case ASM_TOKEN : return "ASM_TOKEN";
		
		case __ATTRIBUTE___TOKEN : return "__attribute__";
		case __EXTENSION___TOKEN : return 	"__extension__";
		
		case LPAREN_TOKEN : return "(";
		case RPAREN_TOKEN : return ")";
		case LBRACK_TOKEN : return "[";
		case RBRACK_TOKEN : return "]";
		case ARROW_TOKEN : return "->";
		case DOT_TOKEN : return ".";
		case NOT_TOKEN : return "!";
		case COMPL_TOKEN : return "~";
		case INCR_TOKEN : return "++";
		case DECR_TOKEN : return "--";
		case MUL_TOKEN : return "*";
		case DIV_TOKEN : return "/";
		case MOD_TOKEN : return "%";
		case PLUS_TOKEN : return "+";
		case MINUS_TOKEN : return "-";
		case SHIFTL_TOKEN : return "<<";
		case SHIFTR_TOKEN : return ">>";
		case LT_TOKEN : return "<";
		case GT_TOKEN : return ">";
		case AND_TOKEN : return "&";
		case XOR_TOKEN : return "^";
		case OR_TOKEN : return "|";
		case LOGAND_TOKEN : return "&&";
		case LOGOR_TOKEN : return "||";
		case QUEST_TOKEN : return "?";
		case COLON_TOKEN : return ":";
		case ASSIGN_TOKEN : return "=";
		case COMMA_TOKEN : return ",";
		case SEMI_TOKEN  : return ";";
		case LBRACE_TOKEN : return "{";
		case RBRACE_TOKEN : return "}";
		case ELLIPSIS_TOKEN : return "...";
		
		case IDENTIFIER_TOKEN : return "IDENTIFIER_TOKEN";
		case STRING_TOKEN : return "STRING_TOKEN";
		case CONSTANT_TOKEN : return "CONSTANT_TOKEN";

		case USING_TOKEN : return "using";
		case NAMESPACE_TOKEN : return "namespace";
		case TEMPLATE_TOKEN : return "template";
		case TRY_TOKEN : return "try";
		case THROW_TOKEN : return "throw";
		case CATCH_TOKEN : return "catch";
		case NEW_TOKEN : return "new";
		case DELETE_TOKEN : return "delete";
		case CXX_TRUE_TOKEN : return "true";
		case CXX_FALSE_TOKEN : return "false";
		case THIS_TOKEN : return "this";
		case OPERATOR_TOKEN : return "operator";
		case CONST_CAST_TOKEN : return "const_cast";
		case STATIC_CAST_TOKEN : return "static_cast";
		case DYNAMIC_CAST_TOKEN : return "dynamic_cast";
		case REINTERPRET_CAST_TOKEN : return "reinterpret_cast";
		case TYPEID_TOKEN : return "typeid";
		case TYPENAME_KEYWORD_TOKEN : return "typename";

		case SCOPE_TOKEN : return "::";
		case LEFT_RIGHT_TOKEN : return "()";
		case PAREN_STAR_PAREN_TOKEN : return "(*)";
		case ARROW_STAR_TOKEN : return "->*";
		case DOT_STAR_TOKEN : return ".*";
	}

	exit(1);return NULL;
}
