
/*
 * Portable Object Compiler (c) 1997, 98.  All Rights Reserved.
 */

#ifdef __PORTABLE_OBJC__

#ifndef __OBJECT_H__
#define __OBJECT_H__

#include "objcrt.h"

#define __objcrt_revision__ "1.8.7"

@interface Object
{
	id isa;
	unsigned short attr;  /* compatibility Stepstone */
	unsigned short objID; /* compatibility Stepstone */
}

+ initialize;
- initialize;

- str:(STR)s;
+ new;
- new;
- copy;
- deepCopy;
- free;
+ free;

- self;
- yourself;
- class;
- superclass;
- superClass;
+ class;
+ superclass;
+ superClass;
- add:anObject;
- (STR) name;
+ (STR) name;
- findClass:(STR)aClassName;
- (SEL) selOfSTR:(STR)aSelName;
- idOfSTR:(STR)aClassName;

- (unsigned) hash;
- (BOOL) isEqual:anObject;
+ (BOOL) isEqual:anObject;
- (BOOL) isSame:anObject;
- (BOOL) notEqual:anObject;
- (BOOL) notSame:anObject;
- (int) compare:anObject;

- (BOOL) respondsTo:(SEL)aSelector;
- (BOOL) isMemberOf:aClass;
- (BOOL) isKindOf:aClass;

+ subclasses;
+ poseAs:superClass;
+ addMethodsTo:superClass;
+ subclass:(STR)name;
+ (BOOL) inheritsFrom:aClass;

- subclassResponsibility:(SEL)aSelector;
- subclassResponsibility;
- notImplemented:(SEL)aSelector;
- notImplemented;
- shouldNotImplement:(SEL)aSelector;
- shouldNotImplement;
- shouldNotImplement:(SEL)aSelector from:superClass;
- doesNotRecognize:(SEL)aSelector;
- doesNotUnderstand:(SEL)aSelector;
- vsprintf:(STR)format:(OC_VA_LIST)ap;
- error:(STR)format,...;
- halt:message;

- (IMP) methodFor:(SEL)aSelector;
+ (IMP) instanceMethodFor:(SEL)aSelector;

- perform:(SEL)aSelector;
- perform:(SEL)aSelector with:anObject;
- perform:(SEL)aSelector with:anObject with:otherObject;
- perform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

- print;
+ print;
- printLine;
- show;
- printToFile:(FILE *)aFile;
- printOn:(IOD)anIOD;

+ (STR) objcrtRevision;

+ readFrom:(STR)aFileName;
- (BOOL) storeOn:(STR)aFileName;

/* compiler generated */
- fileOutIdsFor:aFiler;
- fileInIdsFrom:aFiler;

/* compile without including AsciiFiler */
- fileOut:(void *)value type:(char)typeDesc;
- fileIn:(void *)value type:(char)typeDesc;

- fileOutOn:aFiler;
+ fileInFrom:aFiler;
- fileInFrom:aFiler;
- awake;
- awakeFrom:aFiler;

@end

#endif /* __OBJECT_H__ */

#endif /* __PORTABLE_OBJC__ */


