
/*
 * Portable Object Compiler (c) 1998.  All Rights Reserved.
 */

#ifndef __IDARRAY_H__
#define __IDARRAY_H__

#include "array.h"

typedef struct idary {
    int		count;
    int		capacity;
    id*		ptr;
} *idary_t;

@interface IdArray : Array
{
    struct idary	value;
}

+ new;
+ new:(unsigned)n;
+ with:(unsigned)nArgs,...;
- copy;
- deepCopy;
- free;

- (idary_t) idaryValue;
- (unsigned) size;
- at:(unsigned)anOffset;
- at:(unsigned)anOffset put:anObject;

- printOn:(IOD)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif /* __PORTABLE_OBJC__ */

@end

#endif /* __IDARRAY_H__ */

