
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 */

#ifndef __OBJSET_H__
#define __OBJSET_H__

#include "cltn.h"

typedef struct objset {
    int		count;
    int		capacity;
    id*		ptr;
} *objset_t;

@interface Set : Cltn
{
    struct objset	value;
}

+ new;
+ new:(unsigned)n;
+ with:(int)nArgs,...;
+ with:firstObject with:nextObject;
+ add:firstObject;
- copy;
- deepCopy;
- emptyYourself;
- addYourself;
- freeContents;
- free;

- (objset_t) objsetValue;
- (unsigned) size;
- (BOOL) isEmpty;
- eachElement;

- (unsigned) hash;
- (BOOL) isEqual:aSet;

- add:anObject;
- addNTest:anObject;
- filter:anObject;
- add:anObject ifDuplicate:aBlock;
- replace:anObject;

- remove:oldObject;
- remove:oldObject ifAbsent:exceptionBlock;

- (BOOL) includesAllOf:aCol;
- (BOOL) includesAnyOf:aCol;

- addContentsTo:aCol;
- addContentsOf:aCol;
- addAll:aCol;
- removeContentsOf:aCol;
- removeContentsFrom:aCol;
- removeAll:aCol;

- asSet;
- asOrdCltn;

- detect:aBlock;
- detect:aBlock ifNone:noneBlock;
- select:testBlock;
- reject:testBlock;
- collect:transformBlock;
- (unsigned) count:aBlock;

- elementsPerform:(SEL)aSelector;
- elementsPerform:(SEL)aSelector with:anObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

- do:aBlock;
- do:aBlock until:(BOOL*)flag;

- find:anObject;
- (BOOL) contains:anObject;
- (BOOL) includes:anObject;
- (unsigned) occurrencesOf:anObject;

- intersection:aSet;
- union:aSet;
- difference:aSet;

- printOn:(IOD)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
- awakeFrom:aFiler;
#endif /* __PORTABLE_OBJC__ */

@end

#endif /* __OBJSET_H__ */

