
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 */

#ifndef __COMPSTMT_H__
#define __COMPSTMT_H__

@interface CompoundStatement : Node
{
        int count; /* unique number */
	id lBrace;
	id decls; /* can be nil */
	id body; /* can be nil */
	id rBrace;
	id tmpVars;
	id inlineCaches;
	id myBlocks; /* not including those of subCompounds */
	id blocks; /* including those of subCompounds,
	            * but not including any subBlocks of a Block 
		    * (see -addBlocksTo:)
		    */
	BOOL isMain;
	id outertag; /* linetag of main() */
	id localTypes;
	id localVariables;
	id blockTypes;
	id blockVariables; /* those locals that are referenced from a Block */
}

- addMyBlocksTo:compound;
- setUpLbrace:lToken decls:aDecls body:aBody rbrace:rToken;
+ lbrace:lToken body:aBody rbrace:rToken;
+ lbrace:lToken decls:aDecls body:aBody rbrace:rToken;

- setDeclarators:declarators;
- blockVariables;
- addLocalVars:vars types:types;
- pushLocals;
- popLocals;
- referenceBlockVar:anIdentifier;

- addTempVar:aString;
- addBlock:aBlock;
- addMyBlock:aBlock;
- addInlineCache:aString;
- addTempVarsTo:aStmt;
- addInlineCachesTo:aStmt;
- printTmpVars:aStream from:(int)i to:(int)j;
- printTempVars:aStream;
- printInlineCaches:aStream from:(int)i to:(int)j;
- printInlineCaches:aStream;
- printBlockData:aStream;

- scopeDataTypeName;
- scopeDataName;
- outputScopeDataTypeOn:aStream;
- createScopeOn:aStream;
- copyScopeOn:aStream;

- processBlocks;
- outputBlockDefsOn:aStream;
- translateOn:aStream;
- mainTranslateOn:aStream linetag:aTag;
@end

#endif /* __COMPSTMT_H__ */


