
/*
 * Portable Object Compiler (c) 1998.  All Rights Reserved.
 */

#include "oclib.h"

@implementation Declarators
static id collectTypes,collectVariables;

+ declareLocals:aNode type:typeNode
{
    if (!collectTypes) collectTypes = [Collection new];
    if (!collectVariables) collectVariables = [Collection new];

    /* collect locals while parsing - when the compound is created
     * these collections will be the localVariables and localTypes
     */

    [aNode addIvarsTo:collectVariables addItype:typeNode to:collectTypes];

    return self;
}


#ifndef __PORTABLE_OBJC__
- show { return self; } /* gnu */
#endif

- setUpDecls
{

        if (collectTypes) {
	    types = collectTypes;
	    variables = collectVariables;

	    collectTypes = nil;
	    collectVariables = nil;

	    if ([options debugInfo]) {
		fprintf(stderr,"----declarators-----\n");
		[types show];[variables show];
		fprintf(stderr,"--------------------\n");
	    }
	}

	return self;
}

+ new
{
    return [[super new] setUpDecls];
}

- types
{
    return types;
}

- variables
{
    return variables;
}

@end

