
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 */

#include "oclib.h"
#include "assert.h"

@implementation MethodDeclarator

- free
{
    return nil;
}

- setIsFactory:(BOOL)flag
{
	isFactory = flag;return self;
}

- (BOOL) isFactory
{
	return isFactory;
}

- setResultType:aNode
{
	resultType = aNode;return self;
}

- setSelector:aNode
{
	selector = aNode;return self;
}

- setEllipsis:aToken
{
	ellipsis = aToken;return self;
}


- processMethod
{
	id aMethod = [MethodInfo new];

	assert(selector);[selector processForMethod:aMethod];
	if (ellipsis) [aMethod addEllipsis:ellipsis];
	if (resultType) [aMethod setResultType:resultType];
	[aMethod setIsFactory:isFactory];

	return aMethod;
}

- method
{
	if (!method) method = [self processMethod];
	return method;
}

- addLocalsTo:aCompound
{
    [method addLocalsTo:aCompound];
    return self;
}


- outputCommentOn:aStream
{
	[aStream newline];
	[aStream newline];
	[aStream echo:"/*\n"];
	[aStream echo:" * "];
	[self outputWithoutTagsOn:aStream];
	[aStream echo:"\n */\n"];
	[aStream newline];
	return self;
}

- outputOn:aStream
{
	[aStream echo:(isFactory)?"+":"-"];
	return [super outputOn:aStream];
}

- translateOn:aStream
{
	if ([options comments]) [self outputCommentOn:aStream];

	/* force computation of method */
	[[self method] outputFunctionPrototypeOn:aStream];

	[LineTag forceLineTag];
	return self;
}

- addReferencedScopeToBlock:aMethod
{
    /* instead of just blindly processing nodes, we do it
     * a bit more selectively, by passing this to MethodInfo.
     * so that only arguments are actually processed.
     */
    return [method addReferencedScopeToBlock:aMethod];
}

@end

