
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 */

#ifndef __MESSAGEEXPRESSION_H__
#define __MESSAGEEXPRESSION_H__

@interface MessageExpression : ExpressionNode
{
	id	receiver;
	id      linetag; /* emitted before (objcTx = ...) assignment */
	id	methodMsg;
	id	methodProto;
	id	methodName;
	id	tmpVar;
	id	inlineCache;
	BOOL    isReceiverSuper;
}


- processReceiver:aReceiver;
- processMessageArguments:aMethodDeclarator;
- addTempVarsTo:aStmt;
- addInlineCachesTo:aStmt;

- translateOn:aStream;
- genAssignReceiverToTempOn:aStream;
- genAssignSuperToTempOn:aStream;
- genImpCallOn:aStream inSuper:(BOOL)inSuper;
- genInlineImpCallOn:aStream inSuper:(BOOL)inSuper;
- genCallOn:aStream inSuper:(BOOL)inSuper;
- translateMessageArgumentsOn:aStream inSuper:(BOOL)inSuper;
- genMessageOn:aStream inSuper:(BOOL)inSuper;
- translateMessageOn:aStream;
- translateSuperMessageOn:aStream;
@end

#endif /* __MESSAGEEXPRESSION_H__ */

